package com.qmth.distributed.print.business.activiti;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.qmth.teachcloud.common.contant.SpringContextHolder;
import com.qmth.teachcloud.common.entity.SysOrg;
import com.qmth.teachcloud.common.entity.SysUser;
import com.qmth.teachcloud.common.service.SysOrgService;
import com.qmth.teachcloud.common.service.SysUserService;
import com.qmth.teachcloud.common.util.ServletUtil;
import org.activiti.engine.delegate.DelegateTask;
import org.activiti.engine.delegate.TaskListener;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

/**
 * @Description: 教学院长审批
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2021/7/29
 */
public class PresidentApproveListener implements TaskListener {
    private final static Logger log = LoggerFactory.getLogger(PresidentApproveListener.class);

    /**
     * 查找同级和以上人员
     *
     * @param delegateTask
     */
    @Override
    public void notify(DelegateTask delegateTask) {
        SysOrgService sysOrgService = SpringContextHolder.getBean(SysOrgService.class);
        SysUserService sysUserService = SpringContextHolder.getBean(SysUserService.class);

        SysUser sysUser = (SysUser) ServletUtil.getRequestUser();
        List<SysOrg> sysOrgList = sysOrgService.findByConnectByParentId(sysUser.getOrgId());
        Set<Long> orgIds = sysOrgList.stream().map(s -> s.getId()).collect(Collectors.toSet());

        QueryWrapper<SysUser> sysUserQueryWrapper = new QueryWrapper<>();
        sysUserQueryWrapper.lambda().eq(SysUser::getSchoolId, sysUser.getSchoolId())
                .in(SysUser::getOrgId, orgIds);
        List<SysUser> sysUserList = sysUserService.list(sysUserQueryWrapper);
        List<String> ids = sysUserList.stream().map(s -> String.valueOf(s.getId())).collect(Collectors.toList());
        //添加或签的人员，一人通过即可进入下一环节
        delegateTask.addCandidateUsers(ids);
    }
}